package com.createall.recyclerviewtest;

import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.util.Log;

import com.createall.recyclerviewtest.adapter.UserAdapter;
import com.createall.recyclerviewtest.model.UserModel;
import com.createall.recyclerviewtest.service.IApiService;
import com.createall.recyclerviewtest.service.RestClient;
import com.facebook.stetho.Stetho;

import java.util.ArrayList;

import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;

public class MainActivity extends AppCompatActivity {
    private String mClassName = getClass().getName().trim();

    private RecyclerView mRecyclerView;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Stetho.initializeWithDefaults(this);
        setContentView(R.layout.activity_main);

        mRecyclerView = (RecyclerView)findViewById(R.id.recycler_view);
        mRecyclerView.setLayoutManager(new LinearLayoutManager(this));

        IApiService iApiService = new RestClient("http://www.json-generator.com/").getApiService();

        Call<ArrayList<UserModel>> call = iApiService.getUserList();
        try {
            call.enqueue(new Callback<ArrayList<UserModel>>() {
                @Override
                public void onResponse(Call<ArrayList<UserModel>> call, Response<ArrayList<UserModel>> response) {
                    if (response.isSuccessful()) {
                        try {
                            UserAdapter ua = new UserAdapter(response.body());
                            mRecyclerView.setAdapter(ua);
                        }
                        catch(Exception e) {
                            Log.d(mClassName, e.toString());
                        }
                    }
                }

                @Override
                public void onFailure(Call<ArrayList<UserModel>> call, Throwable t) {
                    Log.d(mClassName, t.getMessage());
                }
            });
        }
        catch(Exception e) {
            Log.d(mClassName, e.getMessage());
        }
    }
}
