package com.createall.recyclerviewtest.adapter;

import android.support.v7.widget.RecyclerView.Adapter;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import com.bumptech.glide.Glide;
import com.createall.recyclerviewtest.R;
import com.createall.recyclerviewtest.model.UserModel;

import java.util.ArrayList;

/**
 * Created by Lee on 2017-06-23.
 */

public class UserAdapter extends Adapter<UserViewHolder> {
    private ArrayList<UserModel> mList;

    public UserAdapter(ArrayList<UserModel> list) {
        mList = list;
    }

    @Override
    public UserViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        View v = LayoutInflater.from(parent.getContext()).inflate(R.layout.user_item, parent, false);
        return new UserViewHolder(v);
    }

    @Override
    public void onBindViewHolder(UserViewHolder holder, int position) {
        Glide.with(holder.itemView.getContext())
                .load(mList.get(position).getPicture() + "#" + position + System.currentTimeMillis()) //Glide가 동일한 URL일 때, 캐싱한 것을 보여주기 때문에 각각 URL을 틀리게 하기 위해 position과 현재 시각을 추가함
                .into(holder.mImageView);
        holder.mUserName.setText(mList.get(position).getName());
        holder.mUserEmail.setText(mList.get(position).getEmail());
        holder.mUserPhone.setText(mList.get(position).getPhone());
    }

    @Override
    public int getItemCount() {
        return mList.size();
    }
}
